easyprogramcheckin/urls.py
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path

from easyprogramcheckin import settings

urlpatterns = [
    path('', include('courses.urls')),
    path('assignments/', include('assignments.urls')),
    path('languages/', include('languages.urls')),
    path('registration/', include('users.urls')),
    path('admin/', admin.site.urls),
    path('view_feedback', include('feedback.urls'))
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

languages/urls.py
from django.urls import path

from languages.views import CreateLanguageView

urlpatterns = [
    path('create_language', CreateLanguageView.as_view(), name='create_language'),
]

users/urls.py
from django.urls import path
from users.views import SignUpView, ProfileView
from users.forms import UserAuthenticationForm
from django.contrib.auth import views as viewsauth
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('signup/', SignUpView.as_view(extra_context={'title': 'Sign Up'}), name='signup'),
    path('login/', viewsauth.LoginView.as_view(template_name='registration/login.html',
                                               form_class=UserAuthenticationForm,
                                               extra_context={'title': 'Login'}),
         name='login'),
    path('profile/', ProfileView.as_view(extra_context={'title': 'Profile'}), name='profile'),
    path('logout/', viewsauth.LogoutView.as_view(), name='logout')
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

languages/models.py
from django.db import models

# Create your models here.

class Language(models.Model):
    name = models.CharField(max_length=15, blank=False)
    compile_command = models.CharField(max_length=100, blank=True)
    run_command = models.CharField(max_length=100, blank=False)

    def __str__(self):
        return self.name

    def get_absolute_url(self):
        return '/'

languages/forms.py
from django import forms
from languages.models import Language

class CreateLanguageForm(forms.ModelForm):
    class Meta:
        model = Language
        fields = ['name', 'compile_command', 'run_command']

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.fields['name'].widget.attrs['class'] = 'form-control'
        self.fields['compile_command'].widget.attrs['class'] = 'form-control'
        self.fields['run_command'].widget.attrs['class'] = 'form-control'

languages/views.py
from languages.models import Language
from languages.forms import CreateLanguageForm
from django.views.generic.edit import CreateView
from django.contrib.auth.mixins import UserPassesTestMixin, LoginRequiredMixin


class CreateLanguageView(LoginRequiredMixin, UserPassesTestMixin, CreateView):
    model = Language
    form_class = CreateLanguageForm

    def test_func(self):
        account = self.request.user.account
        teaching_courses = account.teaching_courses.all()
        assistant_courses = account.assistant_courses.all()
        return (teaching_courses | assistant_courses).exists()

languages/templates/languages/language_form.html
{% extends 'main_app/base.html' %}

{% load static %}

{% block specific_css %}
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <link rel="stylesheet" type="text/css" href="{% static 'assignments/css/form.css' %}">
{% endblock specific_css %}

{% block content %}
    {# Django Tempus Dominus assets are included in `{{ form.media }}` #}
    {{ form.media }}

    <div class="container">
        <div class="row my-5">
            <div class="col-1"></div>
            <div class="col-10">
                <h1>New Language</h1>
                {% if form.errors %}
                    {% for field in form %}
                        {% for error in field.errors %}
                            <div class="alert alert-danger">
                                <strong>{{ error|escape }}</strong>
                            </div>
                        {% endfor %}
                    {% endfor %}
                    {% for error in form.non_field_errors %}
                        <div class="alert alert-danger">
                            <strong>{{ error|escape }}</strong>
                        </div>
                    {% endfor %}
                {% endif %}
                <form method="post" enctype="multipart/form-data" onsubmit="clearStorage()">
                    {% csrf_token %}
                    <div class="form-group">
                        <label for="id_name"><strong>Language Name<span
                                class="required_field">*</span></strong></label>
                        {{ form.name }}
                    </div>
                    <div class="form-group">
                        <label for="id_compile_command"><strong>Compile Command</strong></label>
                        <small id="source_help" class="form-text text-muted">The commands are run on the file directory. Following tokens are available:
                            <ul>
                                <li>{file} for the filename.</li>
                                <li>{efile} for the extensionless filename.</li>
                            </ul>
                        </small>
                        {{ form.compile_command }}
                        <small id="source_help" class="form-text text-muted">Leave empty if the language is interpreted.</small>
                    </div>
                    <div class="form-group">
                        <label for="id_run_command"><strong>Run Command<span
                                class="required_field">*</span></strong></label>
                        <small id="source_help" class="form-text text-muted">The same tokens from above are available.</small>
                        {{ form.run_command }}
                    </div>
                    <button type="submit" class="btn btn-primary">Submit</button>
                </form>
            </div>
        </div>
    </div>
{% endblock content %}

{% block specific_js %}
    <script type="text/javascript">
        let saveStorage = true;

        // save field values
        window.onbeforeunload = () => {
            if (saveStorage) {
                sessionStorage.setItem("name", $('#id_name').val());
                sessionStorage.setItem("compile_command", $('#id_compile_command').val());
                sessionStorage.setItem("run_command", $('#id_run_command').val());
            }
        };

        // restore field values
        window.onload = () => {
            let name = sessionStorage.getItem("name");
            if (name !== null) $('#id_name').val(name);
            let compile_command = sessionStorage.getItem("compile_command");
            if (compile_command !== null) $('#id_compile_command').val(compile_command);
            let run_command = sessionStorage.getItem("run_command");
            if (run_command !== null) $('#id_run_command').val(run_command);
        };

        function clearStorage() {
            saveStorage = false;
            sessionStorage.clear();
        }
    </script>
{% endblock specific_js %}